/*=============================================================================
*								R[hϊ
*
=============================================================================*/

/*	Copyright(C) 1998-2001 ]c(Sota) 
*	vOύXĔЕzۂ́A\[XR[hƋɃt[E\tgEGA
*	ĔЕzĂB */

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mbstring.h>
#include <windowsx.h>
#include <locale.h>

#include "common.h"
#include "resource.h"

#define CONV_ASCII		0		/* ASCII */
#define CONV_KANJI		1		/*  */
#define CONV_KANA		2		/* pJ^Ji */

#if 0
/*===== vg^Cv =====*/
static int CheckOnSJIS(uchar *Pos, uchar *Btm);
static int CheckOnEUC(uchar *Pos, uchar *Btm);
#endif


/*----- R[hϊ --------------------------------------------
*
*	Parameter
*		CODECONVINFO *cInfo : R[hϊ
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void InitCodeConvInfo(CODECONVINFO *cInfo)
{
	cInfo->KanaCnv = NO;

	cInfo->EscProc = 0;
	cInfo->KanjiMode = CONV_ASCII;
	cInfo->KanjiFst = 0;
	return;
}

/*----- R[hϊ̎co ----------------------------------------
*
*	Parameter
*		CODECONVINFO *cInfo : R[hϊ
*
*	Return Value
*		int ԂtO (=NO)
*
*	Note
*		R[hϊ̍ŌɌĂԎ
*----------------------------------------------------------------------------*/

int FlushRestData(CODECONVINFO *cInfo)
{
	char *Put;

	Put = cInfo->Buf;

	if(cInfo->KanjiFst != 0)
		*Put++ = cInfo->KanjiFst;
	if(cInfo->EscProc >= 1)
		*Put++ = cInfo->EscCode[0];
	if(cInfo->EscProc == 2)
		*Put++ = cInfo->EscCode[1];

	cInfo->OutLen = Put - cInfo->Buf;

	return(NO);
}


/*----- EUCR[hSHIFT-JISR[hɕϊ ------------------------------
*
*	Parameter
*		CODECONVINFO *cInfo : R[hϊ
*
*	Return Value
*		int ԂtO (YES/NO)
*
*	Note
*		ԂtOYES̎́AcInfo̓eςɂxĂԂ
*----------------------------------------------------------------------------*/
int ConvEUCtoSJIS(CODECONVINFO *cInfo)
{
	int Kcode;
	char *Str;
	char *Put;
	char *Limit;
	int Continue;

	Continue = NO;
	Str = cInfo->Str;
	Put = cInfo->Buf;
	Limit = cInfo->Buf + cInfo->BufSize - 2;

	for(; cInfo->StrLen > 0; cInfo->StrLen--)
	{
		if(Put >= Limit)
		{
			Continue = YES;
			break;
		}

		if((*Str & 0x80) != 0)
		{
			if(cInfo->KanjiFst == 0)
				cInfo->KanjiFst = *Str++;
			else
			{
				if((uchar)cInfo->KanjiFst == (uchar)0x8E)	/* pJ^Ji */
					*Put++ = *Str++;
				else
				{
					Kcode = _mbcjistojms(((cInfo->KanjiFst & 0x7F) * 0x100) + (*Str++ & 0x7F));
					*Put++ = HIGH8(Kcode);
					*Put++ = LOW8(Kcode);
				}
				cInfo->KanjiFst = 0;
			}
		}
		else
		{
			if(cInfo->KanjiFst != 0)
			{
				*Put++ = cInfo->KanjiFst;
				cInfo->KanjiFst = 0;
			}
			*Put++ = *Str++;
		}
	}

	cInfo->Str = Str;
	cInfo->OutLen = Put - cInfo->Buf;

	return(Continue);
}


/*----- JISR[hSHIFT-JISR[hɕϊ ------------------------------
*
*	Parameter
*		CODECONVINFO *cInfo : R[hϊ
*
*	Return Value
*		int ԂtO (YES/NO)
*
*	Note
*		ԂtOYES̎́AcInfo̓eςɂxĂԂ
*
*		GXP[vR[h́Â̂ɑΉĂ
*			Jn		<ESC>$B		<ESC>$@
*			pJiJn	<ESC>(I
*			I		<ESC>(B		<ESC>(J		<ESC>(H
*----------------------------------------------------------------------------*/
int ConvJIStoSJIS(CODECONVINFO *cInfo)
{
	int Kcode;
	char *Str;
	char *Put;
	char *Limit;
	int Continue;

	Continue = NO;
	Str = cInfo->Str;
	Put = cInfo->Buf;
	Limit = cInfo->Buf + cInfo->BufSize - 3;

	for(; cInfo->StrLen > 0; cInfo->StrLen--){
		if(Put >= Limit)
		{
			Continue = YES;
			break;
		}

		if(cInfo->EscProc == 0)
		{
			if(*Str == 0x1B)
			{
				if(cInfo->KanjiFst != 0)
				{
					*Put++ = cInfo->KanjiFst;
					cInfo->KanjiFst = 0;
				}
				cInfo->EscCode[cInfo->EscProc] = *Str++;
				cInfo->EscProc++;
			}
			else
			{
				if(cInfo->KanjiMode == CONV_KANA)
				{
					if(cInfo->KanjiFst != 0)
					{
						*Put++ = cInfo->KanjiFst;
						cInfo->KanjiFst = 0;
					}

					if((*Str >= 0x21) && (*Str <= 0x5F))
						*Put++ = (uchar)*Str++ + (uchar)0x80;
					else
						*Put++ = *Str++;
				}
				else if(cInfo->KanjiMode == CONV_KANJI)
				{
					if((*Str >= 0x21) && (*Str <= 0x7E))
					{
						if(cInfo->KanjiFst == 0)
							cInfo->KanjiFst = *Str++;
						else
						{
							Kcode = _mbcjistojms((cInfo->KanjiFst * 0x100) + *Str++);
							*Put++ = HIGH8(Kcode);
							*Put++ = LOW8(Kcode);
							cInfo->KanjiFst = 0;
						}
					}
					else
					{
						if(cInfo->KanjiFst == 0)
							*Put++ = *Str++;
						else
						{
							*Put++ = cInfo->KanjiFst;
							*Put++ = *Str++;
							cInfo->KanjiFst = 0;
						}
					}
				}
				else
					*Put++ = *Str++;
			}
		}
		else if(cInfo->EscProc == 1)
		{
			if((*Str == '$') || (*Str == '('))
			{
				cInfo->EscCode[cInfo->EscProc] = *Str++;
				cInfo->EscProc++;
			}
			else
			{
				*Put++ = cInfo->EscCode[0];
				*Put++ = *Str++;
				cInfo->EscProc = 0;
			}
		}
		else if(cInfo->EscProc == 2)
		{
			if((cInfo->EscCode[1] == '$') && ((*Str == 'B') || (*Str == '@')))
				cInfo->KanjiMode = CONV_KANJI;
			else if((cInfo->EscCode[1] == '(') && (*Str == 'I'))
				cInfo->KanjiMode = CONV_KANA;
			else if((cInfo->EscCode[1] == '(') && ((*Str == 'B') || (*Str == 'J') || (*Str == 'H')))
				cInfo->KanjiMode = CONV_ASCII;
			else
			{
				*Put++ = cInfo->EscCode[0];
				*Put++ = cInfo->EscCode[1];
				if((cInfo->KanjiMode == CONV_KANJI) && ((*Str >= 0x21) && (*Str <= 0x7E)))
					cInfo->KanjiFst = *Str;
				else
					*Put++ = *Str;
			}
			Str++;
			cInfo->EscProc = 0;
		}
	}

	cInfo->Str = Str;
	cInfo->OutLen = Put - cInfo->Buf;

	return(Continue);
}

int ConvUTF8toSJIS(CODECONVINFO *cInfo)
{
	int				i;
	int				j;
	int				k;
	int				nUTF8Bytes;
	int				nUNICODEBytes;
	unsigned char	pWork[100];
	int nBufLen;

	char * pBuf = cInfo->Str;
	char * pDes = cInfo->Buf;
	nBufLen = cInfo->StrLen;

	setlocale( LC_ALL, "Japanese" );
	
	k = 0;
	for( i = 0; i < nBufLen; ){
		// UTF-8̕
		nUTF8Bytes = IsUTF8( &pBuf[i], nBufLen - i );
		switch( nUTF8Bytes ){
		case 1:
		case 2:
		case 3:
			nUNICODEBytes = DecodeUTF8toUnicode( &pBuf[i], nUTF8Bytes, pWork );

			if( 2 == nUNICODEBytes ){
				j = wctomb( (char*)&(pDes[k]), ((wchar_t*)pWork)[0] );
				if( -1 == j ){
					memcpy( &pDes[k], &pBuf[i], nUTF8Bytes );
					k += nUTF8Bytes;
				}else{
					k += j;
				}
			}else{
				memcpy( &pDes[k], &pBuf[i], nUTF8Bytes );
				k += nUTF8Bytes;
			}

			i += nUTF8Bytes;
			break;

		default:
			pDes[k] = pBuf[i];
			++i;
			k++;
			break;
		}
	}
	cInfo->Str = pBuf;
	cInfo->OutLen = k;
	return k;
}

// R[hϊ UnicodeSJIS
int ConvUnicodetoSJIS(CODECONVINFO *cInfo)
{
	char*			pBufUnicode;
	int				nBufUnicodeLen;
	unsigned char*	pBuf;
	pBuf = (unsigned char*)cInfo->Str;

//	BOM̍폜͂ł͂Ȃ悤ɕύX
//	ĂяoőΏĂ 2002/08/30 Moca
	nBufUnicodeLen = MemUnicodeToSJIS( &pBufUnicode, cInfo->Str, cInfo->StrLen );
	// 悭킩񂯂ǁCŏ2΂܂
	strcpy( cInfo->Buf, pBufUnicode+2 );
	cInfo->OutLen = nBufUnicodeLen-2;
	free(pBufUnicode);

	return nBufUnicodeLen;
}


/*----- gĂ銿R[h𒲂ׂ ----------------------------------------
*
*	Parameter
*		char *Text : 
*		char *Btm : ̖
*		int Pref : D(CODE_SJIS / CODE_EUC)
*
*	Return Value
*		int R[h (CODE_xxx)
*----------------------------------------------------------------------------*/
#if 0
int CheckKanjiCode(char *Text, int Size, int Pref)
{
	uchar *Pos;
	uchar *Btm;
	int Ret;
	int PointSJIS;
	int PointEUC;

	Ret = CODE_SJIS;
	if(Size >= 2)
	{
		Ret = -1;
		Btm = Text + Size;

		/* JISR[h̃`FbN */
		Pos = Text;
		while((Pos = memchr(Pos, 0x1b, Btm-Pos-2)) != NULL)
		{
			Pos++;
			if((memcmp(Pos, "$B", 2) == 0) ||	/* <ESC>$B */
			   (memcmp(Pos, "$@", 2) == 0) ||	/* <ESC>$@ */
			   (memcmp(Pos, "(I", 2) == 0))		/* <ESC>(I */
			{
				Ret = CODE_JIS;
				break;
			}
		}

		/* EUCSHIFT-JISR[h̃`FbN */
		if(Ret == -1)
		{
			Ret = Pref;
			Pos = Text;
			while(Pos < Btm)
			{
				PointSJIS = CheckOnSJIS(Pos, Btm);
				PointEUC = CheckOnEUC(Pos, Btm);
				if(PointSJIS > PointEUC)
				{
					Ret = CODE_SJIS;
					break;
				}
				if(PointSJIS < PointEUC)
				{
					Ret = CODE_EUC;
					break;
				}
				if((Pos = memchr(Pos, '\n', Btm-Pos)) == NULL)
					break;
				Pos++;
			}
		}
	}
	return(Ret);
}

/*----- SHIFT-JISR[h̉\邩`FbN --------------------------------
*
*	Parameter
*		uchar *Pos : 
*		uchar *Btm : ̖
*
*	Return Value
*		int _
*
*	Note
*		High	81-FF (A0-DF͔p)	(EBȍ~͂قƂǖ)
*		Low		40-FC
*----------------------------------------------------------------------------*/

static int CheckOnSJIS(uchar *Pos, uchar *Btm)
{
	int FstOnTwo;
	int Point;

	FstOnTwo = NO;
	Point = 100;
	while((Point > 0) && (Pos < Btm) && (*Pos != '\n'))
	{
		if(FstOnTwo == YES)
		{
			if((*Pos < 0x40) || (*Pos > 0xFC))	/* 2oCgڂ 0x40`0xFC */
				Point = 0;
			FstOnTwo = NO;
		}
		else if(*Pos >= 0x81)
		{
			if((*Pos < 0xA0) || (*Pos > 0xDF))	/* pJiłȂ */
			{
				if(*Pos >= 0xEB)		/* 1oCgڂ0xEBȍ~͂قƂǖ */
					Point -= 50;
				FstOnTwo = YES;
			}
		}
		Pos++;
	}
	if(FstOnTwo == YES)		/* PoCgڂŏIĂ̂͂  */
		Point = 0;

	return(Point);
}


/*----- EUCR[h̉\邩`FbN -------------------------------------
*
*	Parameter
*		uchar *Pos : 
*		uchar *Btm : ̖
*
*	Return Value
*		int _
*
*	Note
*		High	A1-FE , 8E
*		Low		A1-FE
*----------------------------------------------------------------------------*/

static int CheckOnEUC(uchar *Pos, uchar *Btm)
{
	int FstOnTwo;
	int Point;

	FstOnTwo = 0;
	Point = 100;
	while((Point > 0) && (Pos < Btm) && (*Pos != '\n'))
	{
		if(FstOnTwo == 1)
		{
			if((*Pos < 0xA1) || (*Pos > 0xFE))	/* 2oCgڂ 0xA1`0xFE */
				Point = 0;
			FstOnTwo = 0;
		}
		else if(FstOnTwo == 2)		/* pJi */
		{
			if((*Pos < 0xA0) || (*Pos > 0xDF))	/* 2oCgڂ 0xA0`0xDF */
				Point = 0;
			FstOnTwo = 0;
		}
		else
		{
			if(*Pos == 0x8E)		/* 0x8E??͔pJi */
				FstOnTwo = 2;
			else if((*Pos >= 0xA1) && (*Pos <= 0xFE))
				FstOnTwo = 1;
		}
		Pos++;
	}
	if(FstOnTwo != 0)		/* PoCgڂŏIĂ̂͂  */
		Point = 0;

	return(Point);
}
#endif



/****
UTF-8̃R[h
	rbg		e
	0xxx xxxx	1oCgR[h
	10xx xxxx	2oCgR[hA3oCgR[h2, 3
	110x xxxx	2oCgR[h̐擪oCg
	1110 xxxx	3oCgR[h̐擪oCg

UTF-8̃GR[fBO
	tH[}bg	Unicode			Unicoderbg						UTFrbg				l
	1oCgR[h	\u0`\u7F		0000 0000 0aaa bbbb					0aaa bbbb
	2oCgR[h	\u80`\u7FF		0000 0aaa bbbb cccc					110a aabb 10bb cccc
	3oCgR[h	\u800`\uFFFF	aaaa bbbb cccc dddd					1110 aaaa 10bb bbcc 10cc dddd
	4oCgR[h	Surrogate		110110wwwwzzzzyy + 110111yyyyxxxxxx 1111 0uuu 10uu zzzz 10yy yyyy 10xx xxxx Javał͖gp
***/


/*!  Shift_JIS ̊1oCgځH ̔
	@author SUI
*/
BOOL _IS_SJIS_1(unsigned int ch)
{
	return (ch ^ 0x20) - 0xa1 < 0x3c;
}

/*!  Shift_JIS ̊2oCgځH ̔
	@author SUI
*/
BOOL _IS_SJIS_2(unsigned int ch)
{
	return ( ch >=0x040 )&&( ch <=0x07E || (( ch >=0x080 )&&( ch <=0x0FC )));
}

#define NA -1
int IsBASE64Char( char cData )
{
	static const int nBASE64Table[] = {
					62, NA, NA, NA, 63,	//	+,-./
		52, 53, 54, 55, 56, 57, 58, 59,	//	01234567
		60, 61, NA, NA, NA, NA, NA, NA,	//	89:;<=>?
		NA,  0,  1,  2,  3,  4,  5,  6,	//	@ABCDEFG
		 7,  8,  9, 10, 11, 12, 13, 14,	//	HIJKLMNO
		15, 16, 17, 18, 19, 20, 21, 22,	//	PQRSTUVW
		23, 24, 25, NA, NA, NA, NA, NA,	//	XYZ[\]^_
		NA, 26, 27, 28, 29, 30, 31, 32,	//	`abcdefg
		33, 34, 35, 36, 37, 38, 39, 40,	//	hijklmno
		41, 42, 43, 44, 45, 46, 47, 48,	//	pqrstuvw
		49, 50, 51						//	xyz
	};
	//	Oct. 10, 2000 genta
	if( cData < '+' || 'z' < cData ){
		return  -1;
	}
	return nBASE64Table[cData - '+'];
}

const char* MemCharNext( const char* pData, int nDataLen, const char* pDataCurrent )
{
	const char*	pNext;
	if( pDataCurrent[0] == '\0' ){
		pNext = pDataCurrent + 1;
	} else {
		if( _IS_SJIS_1( (unsigned char)pDataCurrent[0] ) && _IS_SJIS_2( (unsigned char)pDataCurrent[1] ) )
			pNext = pDataCurrent + 2;
		else pNext = pDataCurrent + 1;
	}

	if( pNext >= &pData[nDataLen] ) pNext = &pData[nDataLen];
	return pNext;
}


/************************************************************************
*
* EUCSpR[h1oCgڂȂTRUE
*
************************************************************************/
int IsEUCKan1( unsigned char c )
{
	/* EUCSpR[h1oCgڂȂTRUE */
	if( c >= 0xa1 && c <= 0xfe ){
		return TRUE;
	}
	return FALSE;
}
/************************************************************************
*
*  EUCSpR[h2oCgڂȂTRUE
*
************************************************************************/
int IsEUCKan2( unsigned char c )
{
	/* EUCSpR[h2oCgڂȂTRUE */
	if( c >= 0xa1 && c <= 0xfe ){
		return TRUE;
	}
	return FALSE;
}

int IsZenHiraOrKata( unsigned short usSrc )
{
	/* SpJ^Ji */
	if( ((unsigned short)0x8340 <= usSrc && usSrc <= (unsigned short)0x837e ) /* @`~ */
	 || ((unsigned short)0x8380 <= usSrc && usSrc <= (unsigned short)0x8393 ) /* ` */
	/* SpЂ炪 */
	 || ((unsigned short)0x829f <= usSrc && usSrc <= (unsigned short)0x82dd ) /* ` */
	 || ((unsigned short)0x82de <= usSrc && usSrc <= (unsigned short)0x82f1 ) /* ށ` */
	){
		return TRUE;
	}else{
		return FALSE;
	}
}

/* ! ̐擪UnicodenBOMtĂ邩H

	@retval	0	Ȃ,o
	@retval	3	(CODE_UNICODE)	Unicode
	@retval	4	(CODE_UTF8)		UTF-8
	@retval	6	(CODE_UNICODEBE) UnicodeBE
*/
int IsUnicodeBom( const unsigned char* pBuf, int nBufLen )
{
	if( NULL == pBuf ){
		return 0;
	}
	if( 2 <= nBufLen ){
		if( pBuf[0] == (unsigned char)0xff &&
			pBuf[1] == (unsigned char)0xfe ){
			return CODE_UNICODE;
		}
		if( pBuf[0] == (unsigned char)0xfe &&
			pBuf[1] == (unsigned char)0xff ){
			return CODE_UNICODEBE;
		}
		if( 3 <= nBufLen ){
			if( pBuf[0] == (unsigned char)0xef &&
				pBuf[1] == (unsigned char)0xbb &&
				pBuf[2] == (unsigned char)0xbf ){
				return CODE_UTF8;
			}
		}
	}
	return 0;
}

/*
||{R[hZbg: UnicodeH
|| G[̏ꍇAFALSEԂ
*/
int CheckKanjiCode_UNICODE( const unsigned char* pBuf, int nBufLen, int* pnMojiNum, int* pnUNICODECodeNum )
{
	int				nMojiNum;
	int				nUNICODECodeNum;

	*pnMojiNum = 0;
	*pnUNICODECodeNum = 0;
	nMojiNum = 0;
	nUNICODECodeNum = 0;

	if( nBufLen < 2 ) return TRUE;

	if( (unsigned char)(pBuf[0	  ]) == (unsigned char)0xff &&
		(unsigned char)(pBuf[0 + 1]) == (unsigned char)0xfe ){
		nMojiNum = 1;
		nUNICODECodeNum = 1;
	}
	*pnMojiNum = nMojiNum;
	*pnUNICODECodeNum = nUNICODECodeNum;
	return TRUE;
}

/*
||{R[hZbg: UnicodeBEH
|| G[̏ꍇAFALSEԂ
*/
int CheckKanjiCode_UNICODEBE( const unsigned char* pBuf, int nBufLen, int* pnMojiNum, int* pnUNICODEBECodeNum ){
	int		nMojiNum;
	int		nUNICODEBECodeNum;

	*pnMojiNum = 0;
	*pnUNICODEBECodeNum = 0;
	nMojiNum = 0;
	nUNICODEBECodeNum = 0;

	if( nBufLen < 2 ) return TRUE;

	if( pBuf[0    ] == (unsigned char)0xfe &&
		pBuf[0 + 1] == (unsigned char)0xff ){
		nMojiNum = 1;
		nUNICODEBECodeNum = 1;
	}
	*pnMojiNum = nMojiNum;
	*pnUNICODEBECodeNum = nUNICODEBECodeNum;
	return TRUE;
}

int CheckKanjiCode_SJIS( const unsigned char* pBuf, int nBufLen, int*	pnMojiNum, int* pnSJISCodeNum )
{
	int				nPtr;
	int				nMojiNum;
	int				nSJISCodeNum;
	int				i;
	int				nCharChars;
	unsigned short	sCode;
	wchar_t			wchar;
	int				j;

	*pnMojiNum = 0;
	*pnSJISCodeNum = 0;
	nMojiNum = 0;
	nSJISCodeNum = 0;
	nPtr = 0;

	for( i = 0; i < nBufLen; ++i ){
		nCharChars = MemCharNext( (const char *)pBuf, nBufLen, (const char *)&(pBuf[i]) ) - (const char*)&(pBuf[i]);
		if( nCharChars == 1 ){
			nMojiNum++;
		}else if( nCharChars == 2 ){
			// Sp
			j = mbtowc( &wchar, (const char*)&pBuf[i], nCharChars );

			sCode =	(unsigned short)_mbcjmstojis(
				(unsigned int)
				(((unsigned short)pBuf[i	] << 8) |
				((unsigned short)pBuf[i + 1]))
				);
			if( !( j == -1 || j == 0 ) && sCode != 0 ){
				nMojiNum++;

				sCode = (((unsigned short)pBuf[i] << 8) | ((unsigned short)pBuf[i + 1]));
				if( 0xe380 > sCode ){
					nSJISCodeNum++;
				}
				++i;
			}else{
				nMojiNum++;
				++i;
			}
		}else if( nCharChars > 0 ){
			nMojiNum++;
			i += nCharChars - 1;
		}
	}
	*pnMojiNum = nMojiNum;
	*pnSJISCodeNum = nSJISCodeNum;
	return TRUE;
}

/*
||{R[hZbg: EUCH
|| G[̏ꍇAFALSEԂ
*/
int CheckKanjiCode_EUC( const unsigned char* pBuf, int nBufLen, int*	pnMojiNum, int* pnEUCCodeNum )
{
	int				nPtr;
	int				nMojiNum;
	int				nEUCCodeNum;
	char			pTest[3];
	unsigned int	sCode;

	*pnMojiNum = 0;
	*pnEUCCodeNum = 0;
	nMojiNum = 0;
	nEUCCodeNum = 0;

	pTest[2] = '\0';
	nPtr = 0;
	while( nPtr < nBufLen ){
		// EUCR[h?
		if( (unsigned char)pBuf[nPtr] == (unsigned char)0x8e ){
			// pJ^Ji
			nMojiNum++;
			nEUCCodeNum++;
			nPtr += 2;
		}else if( nPtr < nBufLen - 1 && IsEUCKan1( pBuf[nPtr] ) && IsEUCKan2( pBuf[nPtr + 1L] ) ){
			// ʏJISR[hɕϊ
			pTest[0] = pBuf[nPtr	 ] & 0x7f;
			pTest[1] = pBuf[nPtr + 1L] & 0x7f;

			// SJISR[hɕϊ	//Sept. 1, 2000 jepro 'Vtg''S'ɕύX
			sCode = (unsigned short)_mbcjistojms(
				(unsigned int)
				(((unsigned short)pTest[0] << 8) |
				((unsigned short)pTest[1]))
				);
			if( sCode != 0 ){
				pTest[0] = (unsigned char)(sCode >> 8);
				pTest[1] = (unsigned char)(sCode);
				nPtr += 2;

				if( IsZenHiraOrKata( sCode ) )
					nEUCCodeNum++;
			}else{
				nPtr++;
			}

			nMojiNum++;
		}else{
			nMojiNum++;
			nPtr++;
		}
	}
	*pnMojiNum = nMojiNum;
	*pnEUCCodeNum = nEUCCodeNum;
	return TRUE;
}

int CheckKanjiCode_JIS( const unsigned char* pBuf, int nBufLen, int* pnMojiNum, int* pnJISCodeNum )
{
	int				nMojiNum;
	int				nJISCodeNum;
	int				i;
	BOOL			bJISKAN, b8BITCODE, nWorkBgn, nWorkLen;

	*pnMojiNum = 0;
	*pnJISCodeNum = 0;
	nMojiNum = 0;
	nJISCodeNum = 0;

	bJISKAN = FALSE;
	b8BITCODE = FALSE;
	for( i = 0; i < nBufLen; i++ ){
		if( i <= nBufLen - 3	 &&
			 pBuf[i + 0] == 0x1b &&
			 pBuf[i + 1] == '$'  &&
			(pBuf[i + 2] == 'B' || pBuf[i + 2] == '@') ){
			b8BITCODE = FALSE;
			bJISKAN = TRUE;
			i += 2;
			nWorkBgn = i + 1;

			nMojiNum += 3;

			continue;
		}
		if( i <= nBufLen - 3	&&
			pBuf[i + 0] == 0x1b	&&
			pBuf[i + 1] == '('	&&
			pBuf[i + 2] == 'I' ){
			if( bJISKAN == TRUE && 0 < i - nWorkBgn ){
				nWorkLen = i - nWorkBgn;

				nMojiNum += ( nWorkLen / 2 );
				nJISCodeNum += ( nWorkLen / 2 );
				bJISKAN = FALSE;
			}
			b8BITCODE = TRUE;
			i += 2;
			nMojiNum += 3;
			continue;
		}
		if( i <= nBufLen - 3	 &&
			 pBuf[i + 0] == 0x1b &&
			 pBuf[i + 1] == '('  &&
			(pBuf[i + 2] == 'B' || pBuf[i + 2] == 'J') ){
			b8BITCODE = FALSE;
			nMojiNum += 3;
			if( bJISKAN == TRUE ){
				nWorkLen = i - nWorkBgn;
				nMojiNum += ( nWorkLen / 2 );
				nJISCodeNum += ( nWorkLen / 2 );
				bJISKAN = FALSE;
				i += 2;
				continue;
			}else
			if( b8BITCODE ){
				b8BITCODE = FALSE;
				i += 2;
				continue;
			}else{
				i += 2;
				continue;
			}
		}else{
			if( b8BITCODE ){
				nMojiNum++;
				nJISCodeNum++;
			}else{
				if( bJISKAN == TRUE ){
					continue;
				}else{
					nMojiNum++;
				}
			}
		}
	}
	*pnMojiNum = nMojiNum;
	*pnJISCodeNum = nJISCodeNum;
	return TRUE;
}


/*
||{R[hZbg: UTF-8H
|| G[̏ꍇAFALSEԂ
*/
int CheckKanjiCode_UTF8( const unsigned char* pBuf, int nBufLen, int* pnMojiNum, int* pnUTF8CodeNum )
{
	int				nMojiNum;
	int				nUTF8CodeNum;
	int				i;
	int				j;
	unsigned char	pDes[64];
	int				nUTF8Bytes;
	int				nUNICODEBytes;
	unsigned char	pWork[100];
	unsigned short*	pusTest;
	unsigned short	usTest;

	*pnMojiNum = 0;
	*pnUTF8CodeNum = 0;
	nMojiNum = 0;
	nUTF8CodeNum = 0;

	setlocale( LC_ALL, "Japanese" );
	for( i = 0; i < nBufLen; ){
		// UTF-8̕
		nUTF8Bytes = IsUTF8( (const unsigned char *)&pBuf[i], nBufLen - i );
		switch( nUTF8Bytes ){
		case 1:
		case 2:
		case 3:
			nUNICODEBytes = DecodeUTF8toUnicode( (const unsigned char *)&pBuf[i], nUTF8Bytes, pWork );
			if( 2 == nUNICODEBytes ){
				j = wctomb( (char*)pDes, ((wchar_t*)pWork)[0] );
				if( -1 == j ){
				}else
				if( 2 == j ){
					pusTest = (unsigned short*)pDes;
					usTest = (((unsigned short)pDes[0] << 8) | ( (unsigned short)pDes[1]) );
					if( IsZenHiraOrKata( usTest ) ){
						nUTF8CodeNum += nUTF8Bytes;
					}
				}
			}else{
			}
			i += nUTF8Bytes;
			break;
		default:
			++i;
			break;
		}
		nMojiNum++;
	}
	*pnMojiNum = nMojiNum;
	*pnUTF8CodeNum = nUTF8CodeNum;
	return TRUE;
}

// BASE64 => GR[h
// 4  => 3

// Base64fR[h
long MemBASE64_Decode( unsigned char* pszSrc, long nSrcLen )
{
	int				i, j, k;
	long			nSrcSize;
	long			lData;
	unsigned char*	pszDes;
	long			nDesLen;
	long			lDesSize;
	int				sMax;

	//Src̗L̎Zo
	for( i = 0; i < nSrcLen; i++ ){
		if( pszSrc[i] == '=' ){
			break;
		}
	}
	nSrcSize = i;
	nDesLen = (nSrcSize / 4) * 3;
	nDesLen += ((nSrcSize % 4) * 6) / 8;
//	pszDes = new unsigned char[nDesLen + 1];
	pszDes = (unsigned char*)malloc(nDesLen + 1);
	memset( pszDes, 0, nDesLen + 1 );

	lDesSize = 0;
	for( i = 0; i < nSrcSize; i++ ){
		if( i < nSrcSize - (nSrcSize % 4) ){
			sMax = 4;
		}else{
			sMax = (nSrcSize % 4);
		}
		lData = 0;
		for( j = 0; j < sMax; j++ ){
			k = IsBASE64Char( pszSrc[i + j] );
			if( k >= 0 ){
				lData |= (((long)k) << ((4 - j - 1) * 6));
			}else{
			}
		}
		for( j = 0; j < (sMax * 6)/ 8 ; j++ ){
			pszDes[lDesSize] = (unsigned char)((lData >> (8 * (2 - j))) & 0x0000ff);
			lDesSize++;
		}
		i+= 3;
	}
	pszDes[lDesSize] = 0;
	memcpy( (char *)pszSrc, (const char *)pszDes, lDesSize );
	//delete [] pszDes;
	free(pszDes);
	return lDesSize;
}

/*
* Base64GR[h
*
*	f[^́AVɊmۂɊi[܂
*	IɁÃnhw肳ꂽAhXɊi[܂
*	ꂽf[^́AꉞNULLI[ɂȂĂ܂
*
*/

int MemBASE64_Encode(
	const char*	pszSrc		,	// GR[hΏۃf[^
	int			nSrcLen		,	// GR[hΏۃf[^
	char**		ppszDes		,	// ʃf[^i[|C^̃AhX
	int			nWrap		,	// GR[h̃f[^ICRLFŐ܂Ԃꍇ̂Pső啶 (-1w肳ꂽꍇ͐܂ԂȂ)
	int			bPadding		// pfBO邩
)
{
	int			i, j, k, m, n;
	long		nDesIdx;
	long		nDataDes;
	long		nDataSrc;
	long		nLineLen;
	char		cw;
	const char	szBASE64CODE[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
//	int			nBASE64CODE_Num = sizeof( szBASE64CODE ) / sizeof( szBASE64CODE[0] );
	int			nDesLen;

	// ̒Zoiwb_[Etb^[j
	//=?ISO-2022-JP?B? GyRC QXc/ Lkgi JE4/ NiRq Siwk MRso Qg== ?=
	nDesLen = ((nSrcLen / 3) + ((nSrcLen % 3)? 1:0)) * 4;
	if( -1 != nWrap ){
		nDesLen += 2 * ( nDesLen / nWrap + ((nDesLen % nWrap)? 1:0 ));
	}

	(*ppszDes) = (char*)malloc(nDesLen + 1);
	memset( (*ppszDes), 0, nDesLen + 1 );

	nDesIdx = 0;
	nLineLen = 0;
	for( i = 0; i < nSrcLen; i += 3 ){
		memcpy( (void *)&nDataDes, "====", 4 );
		nDataSrc = 0;
		if( nSrcLen - i < 3 ){
			k = (nSrcLen % 3) * 8 / 6 + 1;
			for( m = 0; m < nSrcLen % 3; m++ ){
				((char*)&nDataSrc)[3 - m] = pszSrc[i + m];
			}
		}else{
			k = 4;
			for( m = 0; m < 3; m++ ){
				((char*)&nDataSrc)[3 - m] = pszSrc[i + m];
			}
		}
		for( j = 0; j < k; j++ ){
			cw = (char)((nDataSrc >> (6 * (3 - j) + 8)) & 0x0000003f);
			((char*)&nDataDes)[j] = szBASE64CODE[(int)cw];
		}
		if( bPadding ){		// pfBO邩
			k = 4;
		}else{
			nDesLen -= (4 - k);
		}
		for( n = 0; n < k; n++ ){
			// ܂Ԃ̏
			if( nWrap != -1 && nLineLen == nWrap ){
				(*ppszDes)[nDesIdx + 0] = CR;
				(*ppszDes)[nDesIdx + 1] = LF;
				nDesIdx += 2;
				nLineLen = 0;
			}
			(*ppszDes)[nDesIdx] = ((char*)&nDataDes)[n];
			nDesIdx++;
			nLineLen++;
		}
	}
	return nDesLen;
}

/*
||{R[hZbg: UTF-7H
|| G[̏ꍇAFALSEԂ
*/
int CheckKanjiCode_UTF7( const unsigned char* pBuf, int nBufLen, int* pnMojiNum, int* pnUTF7CodeNum )
{
	int			nMojiNum;
	int			nUTF7CodeNum;
	int			i;
	int			j;
	char*		pszWork;
	int			nWorkLen;
	BOOL		bBASE64;
	int			nBgn;
	char		cWork;
	int			nUniBytes;

	*pnMojiNum = 0;
	*pnUTF7CodeNum = 0;
	nMojiNum = 0;
	nUTF7CodeNum = 0;

	setlocale( LC_ALL, "Japanese" );
	bBASE64 = FALSE;
	for( i = 0; i < nBufLen; ++i ){
		if( !bBASE64 ){
			if( i < nBufLen - 1 && '+' == pBuf[i] && '-' == pBuf[i + 1] ){
				//	Apr. 1, 2001 genta
				//	+̃GR[hUTF-7̃|CgΏۊOƂ
				//	nUTF7CodeNum++;
				++i;
			}else if( i < nBufLen - 2
				&& '+' == pBuf[i]
				&& -1 != IsBASE64Char( pBuf[i + 1] ) // Base64̃f[^
				){
				nBgn = i + 1;
				bBASE64 = TRUE;
			}else{
				nMojiNum++;
			}
		} else{
			if( '-' == pBuf[i] ){
				nWorkLen = i - nBgn;
				if( 3 <= nWorkLen ){
					pszWork = (char*)malloc(nWorkLen + 1);
					memset( pszWork, 0, nWorkLen + 1 );
					memcpy( pszWork, &pBuf[nBgn], nWorkLen );
					// Base64fR[h
					nWorkLen = MemBASE64_Decode( (unsigned char *)pszWork, nWorkLen );
					if( 0 == nWorkLen % 2 ){
						nMojiNum += (nWorkLen / 2);
						// 2oCgUnicodeƂOLO/HIoCg
						for( j = 0; j < nWorkLen; j += 2 ){
							cWork = pszWork[j + 1];
							pszWork[j + 1] = pszWork[j];
							pszWork[j] = cWork;
							// ϊ\Unicode
							nUniBytes = wctomb( (char*)NULL, *(wchar_t*)(&pszWork[j]) );
							if( -1 != nUniBytes ){
								nUTF7CodeNum++;
							}
						}
					}else{
					}
//					delete [] pszWork;
					free(pszWork);
				}else{
					nMojiNum++;
				}
				bBASE64 = FALSE;
			}else if( CR == pBuf[i] || LF == pBuf[i] ){
				bBASE64 = FALSE;
			}else{
				if( -1 == IsBASE64Char( pBuf[i] )  ){	// Base64̃f[^
					bBASE64 = FALSE;
					//	Oct. 10, 2000 genta
					if( pBuf[i] & 0x80 ){
						//	8bitR[hĂUTF-7ł͂蓾Ȃ̂ŃJE^0ɖ߂
						nUTF7CodeNum = 0;
					}
				}
			}
		}
	}
	*pnMojiNum = nMojiNum;
	*pnUTF7CodeNum = nUTF7CodeNum;
	return TRUE;
}

/*
|| {R[hZbg
||
|| y߂lz
||	SJIS	0
||	JIS		1
||	EUC		2
||	Unicode	3
||	UTF-8	4
||	UTF-7	5
||	UnicodeBE	6
||	G[	-1
||	G[ȊO enumCodeType g
*/
int CheckKanjiCode( const unsigned char* pBuf, int nBufLen )
{
	int	nEUCMojiNum, nEUCCodeNum;
	int	nSJISMojiNum, nSJISCodeNum;
	int	nJISMojiNum, nJISCodeNum;
	int	nUTF8MojiNum, nUTF8CodeNum;
	int	nUTF7MojiNum, nUTF7CodeNum;
	int	nUnicodeBom;

	nUnicodeBom = IsUnicodeBom( pBuf, nBufLen );
	if( 0 != nUnicodeBom ) return nUnicodeBom;

	// {R[hZbg: EUCH
	CheckKanjiCode_EUC( pBuf, nBufLen, &nEUCMojiNum, &nEUCCodeNum );
	// {R[hZbg: SJISH
	CheckKanjiCode_SJIS( pBuf, nBufLen, &nSJISMojiNum, &nSJISCodeNum );
	// {R[hZbg: JISH
	CheckKanjiCode_JIS( pBuf, nBufLen, &nJISMojiNum, &nJISCodeNum );
	// {R[hZbg: UTF-8H
	CheckKanjiCode_UTF8( pBuf, nBufLen, &nUTF8MojiNum, &nUTF8CodeNum );
	// {R[hZbg: UTF-7H
	CheckKanjiCode_UTF7( pBuf, nBufLen, &nUTF7MojiNum, &nUTF7CodeNum );

	if( nEUCCodeNum > 0 && nEUCCodeNum >= nSJISCodeNum && nEUCCodeNum >= nJISCodeNum && nEUCCodeNum >= nUTF8CodeNum && nEUCCodeNum >= nUTF7CodeNum ){
		return CODE_EUC;	// EUC
	}
	if( nUTF7CodeNum > 0 && nUTF7CodeNum >= nSJISCodeNum && nUTF7CodeNum >= nJISCodeNum && nUTF7CodeNum >= nEUCCodeNum && nUTF7CodeNum >= nUTF8CodeNum ){
		return CODE_UTF7;	// UTF-7
	}
	if( nUTF8CodeNum > 0 && nUTF8CodeNum >= nSJISCodeNum && nUTF8CodeNum >= nJISCodeNum && nUTF8CodeNum >= nEUCCodeNum && nUTF8CodeNum >= nUTF7CodeNum ){
		return CODE_UTF8;	// UTF-8
	}
	if( nJISCodeNum > 0 && nJISCodeNum >= nEUCCodeNum && nJISCodeNum >= nSJISCodeNum && nJISCodeNum >= nUTF8CodeNum && nJISCodeNum >= nUTF7CodeNum ){
		return CODE_JIS;	// JIS
	}

	return 0; // SJIS
}


/* UTF-8̕ */
int IsUTF8( const unsigned char* pData, int nDataLen )
{
	if( 3 <= nDataLen
	 && (unsigned char)0xe0 == (unsigned char)(pData[0] & (unsigned char)0xf0)
	 && (unsigned char)0x80 == (unsigned char)(pData[1] & (unsigned char)0xc0)
	 && (unsigned char)0x80 == (unsigned char)(pData[2] & (unsigned char)0xc0)
	){
		return 3;
	}
	if( 2 <= nDataLen
	 && (unsigned char)0xc0 == (unsigned char)(pData[0] & (unsigned char)0xe0)
	 && (unsigned char)0x80 == (unsigned char)(pData[1] & (unsigned char)0xc0)
	){
		return 2;
	}
	return 0;

}

int DecodeUTF8toUnicode( const unsigned char* pData, int nUTF8Bytes, unsigned char* pDes )
{
	switch( nUTF8Bytes ){
	case 1:
		pDes[1] = 0x00;
		pDes[0] = pData[0];
		return 2;
	case 2:
		pDes[1] = ( pData[0] & 0x1c ) >> 2;
		pDes[0] = ( pData[0] << 6 ) | ( pData[1] & 0x3f );
		return 2;
	case 3:
		pDes[1] =  ( ( pData[0] & 0x0f ) << 4 )
				 | ( ( pData[1] & 0x3c ) >> 2 );
		pDes[0] =  (   pData[2] & 0x3f )
				 | ( ( pData[1] & 0x03 ) << 6 );
		return 2;
	}
	return 0;
}

int MemUnicodeToSJIS( char** ppBufSJIS, const char*pBuf, int nBufLen )
{
	int			i, j, k;
	char*		pBufSJIS;
	wchar_t*	pUniBuf;
	char		mbchar[4];

	setlocale( LC_ALL, "Japanese" );
	pUniBuf = (wchar_t*)pBuf;
	i = 0; k = 0;
	for( i = 0; i < nBufLen / (int)sizeof( wchar_t ); ++i ){
		j = wctomb( (char*)mbchar, pUniBuf[i] );
		if( -1 == j ) k += sizeof( wchar_t );
		else k += j;
	}
 	pBufSJIS = (char*)malloc(k);

	k = 0;
	for( i = 0; i < nBufLen / (int)sizeof( wchar_t ); ++i ){
		j = wctomb( (char*)&(pBufSJIS[k]), pUniBuf[i] );
		if( -1 == j ){
			memcpy( &pBufSJIS[k], &pUniBuf[i], sizeof( wchar_t ) );
			k += sizeof( wchar_t );
		}else{
			k += j;
		}
	}
	*ppBufSJIS = pBufSJIS;
	return k;
}

