#include <windows.h>
#include <windowsx.h>
#include <winnls32.h>
#include <stdio.h>
#include <SHLOBJ.h>
#include <limits.h>
#include "common.h"
#include "resource.h"


#define PIXEL_TO_DLGBASE_X(a) (a * LOWORD(GetDialogBaseUnits()) / 4)
#define PIXEL_TO_DLGBASE_Y(a) (a * HIWORD(GetDialogBaseUnits()) / 8)

//---------------------------------------------------------------------------
static HWND GrepWnd = 0;
static HWND ListView = 0;
static RECT ListRect1, ListRect2;
static int GrepCancelFlag = 0;
static int TotalFileNum, CurFileNum;  // GrepΏۃt@CCt@Cڂ

extern char FindHist[FINDHIST_NUM*(FINDSTR_LEN+1)+1];
extern FINDDLGDATA FindData;
extern HACCEL Accel;
extern int GrepWndPortrait;

//---------------------------------------------------------------------------


/*----- tH_I_CAÕR[obN --------------------------------
*       => ڍׂ SDK QƂ̂
*----------------------------------------------------------------------------*/

static int WINAPI BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
    if (uMsg == BFFM_INITIALIZED)
	// ftHgpXo^
        SendMessage(hwnd, BFFM_SETSELECTION, TRUE, lpData);

    return(0);
}


/*----- sԍEChE쐬 ------------------------------------------------
*
*	Parameter
*		HWND Handle : eEChẼEChEnh
*       char *DirPath : tH_󂯎obt@ւ̃AhX
*       char *TitleStr : _CAÕ^Cg
*
*	Return Value
*		BOOL Xe[^X
*			TRUE=Iꂽ
*           FALSE=LZꂽ
*----------------------------------------------------------------------------*/

static BOOL SelectFolder(HWND Handle, char *DirPath, char *TitleStr)
{
    BROWSEINFO BrowsingInfo;    // [U[ItH_\(API`)
    LPITEMIDLIST ItemID;

    memset(&BrowsingInfo, 0, sizeof(BROWSEINFO));
    BrowsingInfo.hwndOwner      = Handle;
    BrowsingInfo.pszDisplayName = DirPath;
    BrowsingInfo.lpszTitle      = TitleStr;
    BrowsingInfo.ulFlags        = BIF_RETURNONLYFSDIRS;  // tH_̂ݑI\
    BrowsingInfo.lpfn           = BrowseCallbackProc;
    BrowsingInfo.lParam         = (LPARAM)DirPath;  // ftHgpXiR[obNj
    ItemID = SHBrowseForFolder(&BrowsingInfo);
    if(ItemID == NULL)
		return(FALSE);               // LZꂽ

    SHGetPathFromIDList(ItemID, DirPath);          // ACeIDXgItH_擾
    GlobalFreePtr(ItemID);                         // ACeIDXg̈J
    return(TRUE);                                  // OK ꂽ
}

/*----- Traversep̎葱Ft@C𐔂 ------------------------------
*
*	Parameter
*       char *basedir : gp
*       char *relpath : gp
*
*	Return Value
*       Ȃ
*   Note
*       O[oϐ TotalFileNum CNg
*----------------------------------------------------------------------------*/
static void CountTotalFileNum(char *basedir, char *relpath)
{
    TotalFileNum++;
}

/*----- Traversep̎葱FSẴt@CXgɉ ------------------
*
*	Parameter
*       char *basedir : fBNg
*       char *relpath : basedir ̑΃pX
*
*	Return Value
*       Ȃ
*----------------------------------------------------------------------------*/
static void AddFileToList(char *basedir, char *relpath)
{
    LV_ITEM item;

    item.mask = LVIF_TEXT;
    item.iItem = INT_MAX;
    item.pszText = relpath;
    item.iSubItem = 0;
    SendMessage(ListView, LVM_INSERTITEM, 0, (LPARAM)&item);
}


/*----- GREP̌ʂ ----------------------------------------
*
*	Parameter
*       FILEMANTBL *pFileTbl : t@C (ʂFoundTblɊ܂)
*       char *file           : t@C
*
*	Return Value
*       Ȃ
*----------------------------------------------------------------------------*/
static void RegisterGrepResult(FILEMANTBL *pFileTbl, char *file)
{
    int i, j;
    int Line, LastLine = -1; // O񌩂s
    FOUNDTBL *Set;
    LV_ITEM item;
    char buf[300], *eol;

    int SetNum = GetFileExtSetNum(pFileTbl);

    j = 0;
    for(Set = pFileTbl->FoundTbl; Set != NULL; Set = Set->Next) {
		for(i = 0; i < Set->StrNum; i++, j++) {

			Line = GetLineNumFromAdrs(pFileTbl, Set->Find[i].Pos);
			if(AskFileExtSet(SetNum)->LineNumType != LINENUM_WP)
				Line = GetLogicalLineNum(pFileTbl, Line);
			Line++;  // 0 n܂

			if(Line == LastLine) {
				item.iSubItem = 1;
				sprintf(buf, "%d*", Line);
				SendMessage(ListView, LVM_SETITEM, 0, (LPARAM)&item);
				continue;
			}

			item.mask = LVIF_TEXT;
			item.iItem = INT_MAX;

			item.pszText = file;
			item.iSubItem = 0;
			item.iItem = SendMessage(ListView, LVM_INSERTITEM, 0, (LPARAM)&item);

			item.pszText = buf;
			sprintf(buf, "%d", Line);
			item.iSubItem = 1;
			SendMessage(ListView, LVM_SETITEM, 0, (LPARAM)&item);

			strncpy(buf, GetLineTopFromAdrs(pFileTbl, Set->Find[i].Pos), sizeof(buf));
			if((eol = strchr(buf, '\n')) != NULL)
				*eol = '\0';  
			item.iSubItem = 2;
			SendMessage(ListView, LVM_SETITEM, 0, (LPARAM)&item);

			LastLine = Line;
		}
		if(i != FOUNDDATAMAX)
			break;
    }
}

/*----- Traversep̎葱FɈ|t@CXgɉ ------
*
*	Parameter
*       char *basedir : fBNg
*       char *relpath : basedir ̑΃pX
*
*	Return Value
*       Ȃ
*----------------------------------------------------------------------------*/

static void SearchTextForGrep(char *dir, char *file)
{
    FILEMANTBL *pFileTbl = NULL;
    char fullpath[MAX_PATH+1 + 10];
    
    // t@CJ
    if(AddFileData(&pFileTbl) == -1)
       return;
    strcpy(fullpath, dir);  SetYenTail(fullpath);  strcat(fullpath, file);
    OpenFileOnBuffer(pFileTbl, fullpath);

    if(pFileTbl->TextSize != 0) {
		wsprintf(fullpath, "(%3d%%) - %s",
				 (int)(100 * ++CurFileNum / TotalFileNum), file);
		SetWindowText(GrepWnd, fullpath);
		SearchText(pFileTbl, 0, FindData.Str, FindData.CapsFlg, FindData.Regexp, DIST_FORWARD);
		
		if(pFileTbl->FoundTbl != NULL && pFileTbl->FoundTbl->StrNum > 0)
			RegisterGrepResult(pFileTbl, file);
		
    }

    RemoveFileData(&pFileTbl, 0);
}
 


/*----- wfBNgȉǂ ----------------------------------------------
*
*	Parameter
*		char *basedir: fBNg
*               char *reldir : fBNg̑΃fBNg
*               char *mask   : t@C}XN
*               int Recursive: ċAIɉ̃fBNgT邩
*               void (*Func)(char *basedir, char *relpath) :
*                               Kt@Cɑ΂R[obN֐
*
*	Return Value
*		Ȃ
*----------------------------------------------------------------------------*/

void Traverse(char *basedir, char *reldir, char *mask,
			  int Recursive, void (*Func)(char *basedir, char *relpath))
{
    HANDLE hFind;
    char tmp[MAX_PATH+1];
    WIN32_FIND_DATA lp;

    strcpy(tmp, basedir);
    SetYenTail(tmp);
    strcat(tmp, reldir);
    SetYenTail(tmp);
    strcat(tmp, "*");

    hFind = FindFirstFile(tmp, &lp);
    if(hFind == INVALID_HANDLE_VALUE)
		return;

    do {
		ProcessMessage();

		if(lp.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
			if(!strcmp(lp.cFileName, "..") || !strcmp(lp.cFileName, "."))
				continue;
			if(!Recursive)
				continue;
			strcpy(tmp, reldir);
			if(strlen(tmp) != 0)
				SetYenTail(tmp);
			strcat(tmp, lp.cFileName);
			SetYenTail(tmp);
			Traverse(basedir, tmp, mask, Recursive, Func);
		}
		else {
			char *pmask = mask;
			while(*pmask != '\0') {
				if(CheckFname(lp.cFileName, pmask))
					goto MATCH;
				pmask += strlen(pmask) + 1;
			}
			continue;
			
			MATCH:
			strcpy(tmp, reldir);
			if(strlen(tmp) != 0)
				SetYenTail(tmp);
			strcat(tmp, lp.cFileName);
			Func(basedir, tmp);
			
		}        
    } while(FindNextFile(hFind, &lp) && !GrepCancelFlag);
	
    FindClose(hFind);
}


/*----- GrepEBhÉił͂ȂԂ́j^Cgݒ --------------
*
*	Parameter
*       Ȃ
*
*	Return Value
*       Ȃ
*----------------------------------------------------------------------------*/

static void SetDefaultWindowTitle(void)
{
    SetWindowText(GrepWnd, "Grep - ttPage");
}


/*----- GrepJn ------------------------------------------------------------
*
*	Parameter
*       char *Dir  : fBNg
*       char *mask : }XN
*
*	Return Value
*       Ȃ
*----------------------------------------------------------------------------*/
void Grep(char *Dir, char *mask)
{
    int Recursive;
    char *c, *next;
	
    // ÕXg
    SendDlgItemMessage(GrepWnd, LISTVIEW_GREP_RESULT, LVM_DELETEALLITEMS, 0, 0);
    // Rg[gps
    EnableWindow(GetDlgItem(GrepWnd, ID_GREPSTOP),    TRUE );
    EnableWindow(GetDlgItem(GrepWnd, IDOK),           FALSE);
    EnableWindow(GetDlgItem(GrepWnd, ID_REF),         FALSE);
    EnableWindow(GetDlgItem(GrepWnd, INP_DIR),        FALSE);
    EnableWindow(GetDlgItem(GrepWnd, INP_MASK),       FALSE);
    EnableWindow(GetDlgItem(GrepWnd, GREP_RECURSIVE), FALSE);
    EnableWindow(GetDlgItem(GrepWnd, FIND_REGEXP),    FALSE);
    EnableWindow(GetDlgItem(GrepWnd, FIND_SELCASE),   FALSE);
    EnableWindow(GetDlgItem(GrepWnd, FIND_EDIT),      FALSE);
    EnableWindow(GetDlgItem(GrepWnd, ID_ALLFILES),    FALSE);
	
	
    if(!PathIsDirectory(Dir)) {
		MessageBox(GrepWnd, "݂ȂtH_w肳Ă܂",
				   Dir/*"Grep G["*/, MB_OK);
    }
    else {
		// }XN` '}XNP\0}XNQ\0}XNR\0\0'
		if(strlen(mask) == 0)
			strcpy(mask, "*\0");
		else {
			for(c = mask; (next = strchr(c, ';')) != NULL; c = next + 1) {
				*next = '\0';
			}
			*(c + strlen(c) + 1) = '\0';
		}
		
		SendDlgItemMessage(GrepWnd, FIND_EDIT, WM_GETTEXT, FINDSTR_LEN+1, (LPARAM)FindData.Str);
		FindData.CapsFlg = SendDlgItemMessage(GrepWnd, FIND_SELCASE, BM_GETCHECK, 0, 0);
		FindData.Regexp = SendDlgItemMessage(GrepWnd, FIND_REGEXP, BM_GETCHECK, 0, 0);
		Recursive = SendDlgItemMessage(GrepWnd, GREP_RECURSIVE, BM_GETCHECK, 0, 0);
		
		// ɓo^
		SetStrToFindHist(FindData.Str);
		
		// 
		GrepCancelFlag = 0;
		CurFileNum = 0;  TotalFileNum = 0;
		Traverse(Dir, "", mask, Recursive, CountTotalFileNum);
		Traverse(Dir, "", mask, Recursive, SearchTextForGrep);
		
		if(!GrepCancelFlag)
			MessageBox(GrepWnd, "Grep܂", "Grep - ttPage", MB_OK);
		else
			MessageBox(GrepWnd, "Grep𒆒f܂", "Grep - ttPage", MB_OK);
    }
	
    EnableWindow(GetDlgItem(GrepWnd, ID_GREPSTOP),    FALSE);
    EnableWindow(GetDlgItem(GrepWnd, IDOK),           TRUE );
    EnableWindow(GetDlgItem(GrepWnd, ID_REF),         TRUE );
    EnableWindow(GetDlgItem(GrepWnd, INP_DIR),        TRUE );
    EnableWindow(GetDlgItem(GrepWnd, INP_MASK),       TRUE );
    EnableWindow(GetDlgItem(GrepWnd, GREP_RECURSIVE), TRUE );
    EnableWindow(GetDlgItem(GrepWnd, FIND_EDIT),      TRUE );
    EnableWindow(GetDlgItem(GrepWnd, ID_ALLFILES),    TRUE );
    EnableWindow(GetDlgItem(GrepWnd, FIND_REGEXP),    TRUE );
    if(SendDlgItemMessage(GrepWnd, FIND_REGEXP, BM_GETCHECK, 0, 0) == 0)
		EnableWindow(GetDlgItem(GrepWnd, FIND_SELCASE), TRUE);
	
    SetDefaultWindowTitle();
    SetFocus(GetDlgItem(GrepWnd, LISTVIEW_GREP_RESULT));
	
}

BOOL CALLBACK GrepDlgProc(HWND hDlg,	// handle to dialog box
						  UINT uMsg,	// message
						  WPARAM wParam,	// first message parameter
						  LPARAM lParam 	// second message parameter
						  )
{
    char folder[MAX_PATH+1], *Pos;
	char mask[FINDSTR_LEN+1+1] = "";
	static char LastSearchedDir[MAX_PATH+1] = "";
    int Recursive;
	
    switch (uMsg) {
    case WM_INITDIALOG:
		SendDlgItemMessage(hDlg, FIND_EDIT, CB_LIMITTEXT, FINDSTR_LEN, 0);
		SendDlgItemMessage(hDlg, INP_DIR,  EM_LIMITTEXT, MAX_PATH, 0);
		SendDlgItemMessage(hDlg, INP_MASK, EM_LIMITTEXT, FINDSTR_LEN, 0);
		SetDlgItemText(hDlg, INP_MASK, "*.*");
		SendDlgItemMessage(hDlg, FIND_SELCASE, BM_SETCHECK, FindData.CapsFlg, 0);
		SendDlgItemMessage(hDlg, FIND_REGEXP,  BM_SETCHECK, FindData.Regexp, 0);
		
		if(FindData.Regexp == YES)
			EnableWindow(GetDlgItem(hDlg, FIND_SELCASE), FALSE);
		EnableWindow(GetDlgItem(hDlg, ID_GREPSTOP), FALSE);
		
		break;
		
    case WM_ACTIVATE:
		if(LOWORD(wParam) == WA_ACTIVE)
			WINNLSEnableIME(NULL, TRUE);	/* IME ON */
		else if(LOWORD(wParam) == WA_INACTIVE)
			WINNLSEnableIME(NULL, FALSE);	/* IME OFF */
		break;
		
    case WM_SHOWWINDOW:
		if((BOOL)wParam == TRUE) { // \  \
			// XV
			while(SendDlgItemMessage(hDlg, FIND_EDIT, CB_DELETESTRING, 0, 0) > 0)
				;
			Pos = FindHist;
			while(*Pos != NUL) {
				SendDlgItemMessage(hDlg, FIND_EDIT, CB_ADDSTRING, 0, (LPARAM)Pos);
				Pos += strlen(Pos) + 1;
			}
			if(strlen(FindData.Str) > 0)
				SendDlgItemMessage(hDlg, FIND_EDIT, WM_SETTEXT, 0, (LPARAM)FindData.Str);
			SendDlgItemMessage(hDlg, FIND_EDIT, CB_SETCURSEL, 0, 0);
			SetFocus(GetDlgItem(hDlg, FIND_EDIT));
		}
		break;

    case WM_NOTIFY:
		switch(LOWORD(wParam)) {
		case LISTVIEW_GREP_RESULT:
			switch(((LPNMHDR)lParam)->code) {
			case LVN_ITEMCHANGED: {
				int nItem, nLine;
				char Fname[MAX_PATH+1], FullPath[MAX_PATH+1], Line[16] = "1";
				if(  !(((NM_LISTVIEW FAR *)lParam)->uOldState & LVIS_SELECTED)
				   && (((NM_LISTVIEW FAR *)lParam)->uNewState & LVIS_SELECTED))
				{
					if((nItem = ((NM_LISTVIEW FAR *)lParam)->iItem) == -1) 
						break;
					// Iꂽt@CJ
					ListView_GetItemText(ListView, nItem, 0, Fname, sizeof(Fname));
					ListView_GetItemText(ListView, nItem, 1, Line, sizeof(Line));
					strcpy(FullPath, LastSearchedDir);
					SetYenTail(FullPath);
					strcat(FullPath, Fname);
					nLine = (strlen(Line) == 0) ? (0) : (atoi(Line) - 1);
					OpenViewFromFile(FullPath, nLine, CODE_AUTO, NO);
				
					if(AskCurFileTbl() == NULL)
						break;
				
					SearchText(AskCurFileTbl(), 0, FindData.Str, 
							   FindData.CapsFlg, FindData.Regexp, DIST_FORWARD);
					InvalidateRect(GetViewWinHwnd(), NULL, FALSE );
					UpdateWindow(GetViewWinHwnd());
				}
				break;
			}
			defualt:
				break;
			}
		}
		break;

    case WM_GETDLGCODE:
        return DLGC_WANTALLKEYS;

    case WM_SIZE: {
		RECT *pListRect;
		int nWidth = LOWORD(lParam);
		int nHeight = HIWORD(lParam);
		if(GrepWndPortrait)
			pListRect = &ListRect2;
		else
			pListRect = &ListRect1;

		SetWindowPos(ListView, 
					 0,
					 pListRect->left,
					 pListRect->top, //Top
					 nWidth  - pListRect->left, //Width
					 nHeight - pListRect->top, //Height
					 SWP_NOACTIVATE |
					 SWP_NOZORDER);
					 }
		break;

    case WM_KEYDOWN:
		if(wParam == VK_ESCAPE) {
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			return FALSE;
		}
		break;
	
    case WM_CLOSE:
		ShowWindow(GrepWnd, SW_HIDE);
		return TRUE;

    case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;

		case IDOK:
			GetDlgItemText(GrepWnd, INP_DIR,  LastSearchedDir, sizeof(LastSearchedDir));
			GetDlgItemText(GrepWnd, INP_MASK, mask,   sizeof(mask));
			Grep(LastSearchedDir, mask);
			break;

		case IDHELP:
			WinHelp(hDlg, AskHelpFilePath(), HELP_CONTEXT, 10);
			break;

		case ID_GREPSTOP:
			GrepCancelFlag = 1;
			break;

		case ID_ALLFILES:
			SendDlgItemMessage(hDlg, LISTVIEW_GREP_RESULT, LVM_DELETEALLITEMS, 0, 0);
			GetDlgItemText(hDlg, INP_DIR,  LastSearchedDir, sizeof(LastSearchedDir));
			GetDlgItemText(hDlg, INP_MASK, mask,   sizeof(mask));
			Traverse(LastSearchedDir, "", mask, NO, AddFileToList);
			break;

		case ID_REF:
			// ݓ͂ꂽtH_𓾂
			GetDlgItemText(hDlg, INP_DIR, folder, sizeof(folder));
			if(!PathIsDirectory(folder))
				strcpy(folder, "");
			// ݓ͂ꂽtH_𓾂
			if(SelectFolder(GrepWnd, folder, "tH_I"))
				SetDlgItemText(hDlg, INP_DIR, folder);
			break;

		case FIND_REGEXP:
			// K\ ON  啶gps
			if(SendDlgItemMessage(hDlg, FIND_REGEXP, BM_GETCHECK, 0, 0) == 1)
				EnableWindow(GetDlgItem(hDlg, FIND_SELCASE), FALSE);
			else
				EnableWindow(GetDlgItem(hDlg, FIND_SELCASE), TRUE);
			break;

		default:
			return FALSE;
		}
		break;

    default:
		return FALSE;
    }
    return TRUE;
}

/*----- Grep _CAOnh擾 ------------------------------------------
*
*	Parameter
*       Ȃ
*
*	Return Value
*       HWND _CAÕnh
*----------------------------------------------------------------------------*/
HWND GetGrepWindow(void)
{
    return GrepWnd;
}

/*----- Grep EBhEftHgTCY ---------------------------------
*
*	Parameter
*       Ȃ
*
*	Return Value
*       Ȃ
*
*----------------------------------------------------------------------------*/
void SetGrepWindowDefaultSize()
{
	RECT *pListRect, WndRect;
	HWND hWnd;
	hWnd = GetGrepWindow();
	if(!hWnd)
		return;
	GetWindowRect(hWnd, &WndRect);
	if(GrepWndPortrait)
		pListRect = &ListRect2;
	else
		pListRect = &ListRect1;
	MoveWindow(hWnd, WndRect.left, WndRect.top, pListRect->right, pListRect->bottom, TRUE);
	UpdateWindow(hWnd);
}
/*----- Grep EBhEJ -----------------------------------------------
*
*	Parameter
*       char *Dir : fBNg̏ݒ
*
*	Return Value
*       HWND _CAÕnh
*----------------------------------------------------------------------------*/
HWND OpenGrepWindow(char *Dir)
{
    HINSTANCE hInstance; 
	HWND ListDummy;
	RECT *pListRect;
    LV_COLUMN column1 = { LVCF_FMT | LVCF_TEXT | LVCF_WIDTH | LVCF_SUBITEM,
						  LVCFMT_LEFT, 100, "t@C", 0, 0 },
			  column2 = { LVCF_FMT | LVCF_TEXT | LVCF_WIDTH | LVCF_SUBITEM,
					LVCFMT_LEFT,  50, "s",         0, 1 },
		      column3 = { LVCF_FMT | LVCF_TEXT | LVCF_WIDTH | LVCF_SUBITEM,
					  LVCFMT_LEFT, 300, "eLXg",   0, 2 };

	if(!GetGrepWindow()) {
		hInstance = GetProgInst();

		GrepWnd = CreateDialog(hInstance, (char*)MAKEINTRESOURCE(grep_dlg),
							   GetMainHwnd(), GrepDlgProc);
		SetWindowPos(GrepWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);


		// LISTVIEW_GREP_DUMMY ̈ʒuɃXgr[𐶐
		ListDummy = GetDlgItem(GrepWnd, LISTVIEW_GREP_DUMMY1);
		GetWindowRect(ListDummy, &ListRect1);
		ScreenToClient(GrepWnd, (POINT*)&ListRect1);
		ScreenToClient(GrepWnd, (POINT*)&ListRect1.right);
		DestroyWindow(ListDummy);

		ListDummy = GetDlgItem(GrepWnd, LISTVIEW_GREP_DUMMY2);
		GetWindowRect(ListDummy, &ListRect2);
		ScreenToClient(GrepWnd, (POINT*)&ListRect2);
		ScreenToClient(GrepWnd, (POINT*)&ListRect2.right);
		DestroyWindow(ListDummy);

		InitCommonControls();
		ListView = CreateWindow(WC_LISTVIEW, "",
								WS_CHILD | WS_VISIBLE | LVS_REPORT | WS_TABSTOP | LVS_SINGLESEL,
								0, 0, 10, 10,
								GrepWnd, (HMENU)LISTVIEW_GREP_RESULT, hInstance , NULL);
		ListView_SetExtendedListViewStyle(ListView, LVS_EX_FULLROWSELECT);

		SetGrepWindowDefaultSize();

		SendMessage(ListView, LVM_INSERTCOLUMN, 0, (LPARAM)&column1);
		SendMessage(ListView, LVM_INSERTCOLUMN, 1, (LPARAM)&column2);
		SendMessage(ListView, LVM_INSERTCOLUMN, 2, (LPARAM)&column3);
	}

	ShowWindow(GrepWnd, SW_SHOW);
	UpdateWindow(GrepWnd);

	if(Dir != NULL) {
		SetDlgItemText(GetGrepWindow(), INP_DIR, Dir);
	}
}


